//+------------------------------------------------------------------+
//|                                              CCIFilterduo V1.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                                                Written by nnjeim |   
//|                                                                  |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_minimum -0.05
#property indicator_maximum 1.05
#property indicator_buffers 6
#property indicator_color1 Blue
#property indicator_color2 CornflowerBlue
#property indicator_color3 LightBlue
#property indicator_color4 Yellow
#property indicator_color5 Orange
#property indicator_color6 Crimson

//---- input parameters
extern int TrendCCI=50;
extern int EntryCCI=14;
extern double UpperTriggerLevel=100;
extern double LowerTriggerLevel=-100;
extern int AlertSig=0;
//---- indicator buffers
double UpBuffer1[];
double UpBuffer2[];
double UpBuffer3[];
double DnBuffer1[];
double DnBuffer2[];
double DnBuffer3[];
double alertTag;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle(4,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle(5,DRAW_HISTOGRAM,STYLE_SOLID,2);
 
   SetIndexBuffer(0,UpBuffer1);
   SetIndexBuffer(1,UpBuffer2);
   SetIndexBuffer(2,UpBuffer3);
   SetIndexBuffer(3,DnBuffer1);
   SetIndexBuffer(4,DnBuffer2);
   SetIndexBuffer(5,DnBuffer3);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   short_name="CCI Filter("+TrendCCI+","+EntryCCI+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"Mild UpTrend");
   SetIndexLabel(2,"Transition");
   SetIndexLabel(3,"Transition");
   SetIndexLabel(4,"Mild DownTrend");
   SetIndexLabel(5,"DownTrend");
   
  
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| CCIFilter                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int shift,trend;
   double CCI0,CCI1;

   for(shift=Bars-TrendCCI-1;shift>=0;shift--)
   {	
   CCI0=iCCI(NULL,0,TrendCCI,PRICE_TYPICAL,shift);
   CCI1=iCCI(NULL,0,EntryCCI,PRICE_TYPICAL,shift);
   	
	  if (CCI0>UpperTriggerLevel && CCI1>UpperTriggerLevel) trend=3;
	  if (CCI0>UpperTriggerLevel && CCI1>0 && CCI1<UpperTriggerLevel) trend=2;
	  if (CCI0>0 && CCI0<UpperTriggerLevel)  trend=2;
	  if (CCI0>0 && CCI1<0)  trend=1;
	
	  if (CCI0<LowerTriggerLevel && CCI1<LowerTriggerLevel) trend=-3;
	  if (CCI0<LowerTriggerLevel && CCI1<0 && CCI1>LowerTriggerLevel) trend=-2;
	  if (CCI0<0 && CCI0>LowerTriggerLevel)  trend=-2;
	  if (CCI0<0 && CCI1>0)  trend=-1;
	  
	  
	  if (trend==3) 
	  {
	  
	  UpBuffer1[shift]=1;
	  UpBuffer2[shift]=0;
	  UpBuffer3[shift]=0;
	  DnBuffer1[shift]=0;
	  DnBuffer2[shift]=0;
	  DnBuffer3[shift]=0;
	  if(AlertSig==1 && alertTag!=Time[0]) {Alert("UP Trend",Symbol()," Period ",Period());alertTag = Time[0];}
	  }
	  if (trend==2) 
	  {
	  
	  UpBuffer1[shift]=0;
	  UpBuffer2[shift]=1;
	  UpBuffer3[shift]=0;
	  DnBuffer1[shift]=0;
	  DnBuffer2[shift]=0;
	  DnBuffer3[shift]=0;
	  if(AlertSig==1 && alertTag!=Time[0]) {Alert("Mild UP Trend ",Symbol()," Period ",Period());alertTag = Time[0];}
	  
	  }
	  
	  if (trend==1) 
	  {
	  
	  UpBuffer1[shift]=0;
	  UpBuffer2[shift]=0;
	  UpBuffer3[shift]=1;
	  DnBuffer1[shift]=0;
	  DnBuffer2[shift]=0;
	  DnBuffer3[shift]=0;
	  if(AlertSig==1 && alertTag!=Time[0]) {Alert("Transition ",Symbol()," Period ",Period());alertTag = Time[0];}
	  
	  }
	  if (trend==-3) 
	  {
	   
	  UpBuffer1[shift]=0;
	  UpBuffer2[shift]=0;
	  UpBuffer3[shift]=0;
	  DnBuffer1[shift]=0;
	  DnBuffer2[shift]=0;
	  DnBuffer3[shift]=1;
	  if(AlertSig==1 && alertTag!=Time[0]) {Alert("Down Trend ",Symbol()," Period ",Period());alertTag = Time[0];}
	  }
	  
	  if (trend==-2) 
	  {
	  
	  UpBuffer1[shift]=0;
	  UpBuffer2[shift]=0;
	  UpBuffer3[shift]=0;
	  DnBuffer1[shift]=0;
	  DnBuffer2[shift]=1;
	  DnBuffer3[shift]=0;
	  if(AlertSig==1 && alertTag!=Time[0]) {Alert("Mild Down Trend ",Symbol()," Period ",Period());alertTag = Time[0];} 
	  
	  }
	  
	  if (trend==-1) 
	  {
	  
	  UpBuffer1[shift]=0;
	  UpBuffer2[shift]=0;
	  UpBuffer3[shift]=0;
	  DnBuffer1[shift]=1;
	  DnBuffer2[shift]=0;
	  DnBuffer3[shift]=0;
	  if(AlertSig==1 && alertTag!=Time[0]) {Alert("Transition ",Symbol()," Period ",Period());alertTag = Time[0];} 
	  
	  }
	}
	return(0);	
 }

